/* ***** BEGIN LICENSE BLOCK *****
   - Version: MPL 1.1/GPL 2.0/LGPL 2.1
   -
   - The contents of this file are subject to the Mozilla Public License Version
   - 1.1 (the "License"); you may not use this file except in compliance with
   - the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License.
   -
   - The Original Code is Bookmark Current Tab Set.
   -
   - The Initial Developer of the Original Code is Jake Kasprzak.
   - Portions created by the Initial Developer are Copyright (C) 2009
   - the Initial Developer. All Rights Reserved.
   -
   - Contributor(s):
   -  Jake Kasprzak <jake@kasprzak.ca>
   -
   - Alternatively, the contents of this file may be used under the terms of
   - either the GNU General Public License Version 2 or later (the "GPL"), or
   - the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   - in which case the provisions of the GPL or the LGPL are applicable instead
   - of those above. If you wish to allow use of your version of this file only
   - under the terms of either the GPL or the LGPL, and not to allow others to
   - use your version of this file under the terms of the MPL, indicate your
   - decision by deleting the provisions above and replace them with the notice
   - and other provisions required by the LGPL or the GPL. If you do not delete
   - the provisions above, a recipient may use your version of this file under
   - the terms of any one of the MPL, the GPL or the LGPL.
   -
   - ***** END LICENSE BLOCK ***** */

//function to create namespaces in order to avoid interference with other add-ons
//refer to: http://blogger.ziesemer.com/2008/05/javascript-namespace-function.html 
String.prototype.namespace = function(separator) {
  var ns = this.split(separator || '.'),
    o = window,
    i,
    len;
  for (i = 0, len = ns.length; i < len; i++) {
    o = o[ns[i]] = o[ns[i]] || {};
  }
  return o;
};


//ca.kasprzak.jake.bcts_initOptions: called when options are first brought up, this initializes the options menu
'ca.kasprzak.jake.bcts_initOptions'.namespace();
ca.kasprzak.jake.bcts_initOptions = function () { 
   
	//retrieve the current preferences and initialize the menu so that the currently selected options appear to be selected initially
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
	prefs = prefs.getBranch("extensions.bcts.");

	var dateFormat = prefs.getCharPref("dateFormat");
	var includeTime = prefs.getBoolPref("includeTime");
	
	var selectedDateFormat = document.getElementById(dateFormat);
	var dateFormats = document.getElementById("dateFormat");
	
	var numOfFormats = dateFormats.itemCount;
	
	for (var i=0; i<numOfFormats; i++) {
		
		if (dateFormats.getItemAtIndex(i).id == dateFormat) {
			
			dateFormats.selectedIndex = i;
		}
	}
	
	var includeTimeCB = document.getElementById("includeTime");
	
	includeTimeCB.checked = includeTime;		
}


//ca.kasprzak.jake.bcts_saveOptions: called when OK is clicked to save the options that the user selected
'ca.kasprzak.jake.bcts_saveOptions'.namespace();
ca.kasprzak.jake.bcts_saveOptions = function () { 

	
	//retrieve the values of items selected in the options menu and save them
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
	prefs = prefs.getBranch("extensions.bcts.");

	var dateFormats = document.getElementById("dateFormat");
	
	var index = dateFormats.selectedIndex;
	
	prefs.setCharPref("dateFormat", dateFormats.getItemAtIndex(index).id);
	
	var includeTimeCB = document.getElementById("includeTime");
	
	prefs.setBoolPref("includeTime", includeTimeCB.checked);
}